<template>
  <span v-html="resolvedValue" />
</template>

<script>
export default {
  props: {
    value: {
      type: Object,
      default: () => ({})
    },
    field: {
      type: Object,
      default: () => ({})
    }
  },
  data: function() {
    return { resolvedValue: "" };
  },
  async created() {
    await this.resolveValue(this.field);
  },
  methods: {
    async resolveValue(field) {
      let value = "";
      if (field.asyncMethod) {
        value = await field.asyncMethod(this.value);
      } else {
        value = field.method(this.value);
      }
      this.resolvedValue = value;
    }
  }
};
</script>
